// Chance, assignment 5.
#include <Servo.h>

Servo servo1;  // my second servo was murdering my power :(

int potpin = 0;  // analog pin used to connect the potentiometer
float val;

// distance sensor stuff
const int trigPin = 3;
const int echoPin = 2;
// distance vars
long duration;
int distance;

void setup() {
  // Servos
  servo1.attach(9);  // attaches the servo on pin 9 to the servo object

  // Distance Sensor
  pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
  pinMode(echoPin, INPUT); // Sets the echoPin as an Input
  SerialUSB.begin(9600); // Starts the serial 
}

//basic lerp used for smoothing, returns int because
float lerp(float a, float b, float f)
{
    return a + (f * (float)(b - a));
}

float prevTime = 0;

void loop() {
  // Servo reading
  int potVal = analogRead(potpin);            // reads the value of the potentiometer (value between 0 and 1023)

  //val = averageVal();
  distance = constrain(distance, 1, 12);
  //float freqVal = map((float) distance, 1.0, 12.0, 0.01, 0.05);
  val = lerp(val, distance, 0.2f);     // lerp for smoothness

  float iciness = map(potVal, 0, 1023, 5, 50);
  iciness = sin(millis()) * iciness * 0.2;
    
  servo1.write((int)(10.0 * val + iciness));    
  //servo2.write(150 - val + 30); // invert second

  // Distance
  // Clears the trigPin
  digitalWrite(trigPin, LOW);
  //delayMicroseconds(2);
  // Sets the trigPin on HIGH state for 10 millis seconds
  digitalWrite(trigPin, HIGH);
  
  delay(10);  // waits for the servo to get there and also the echo conveniently;

  digitalWrite(trigPin, LOW);
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  // Calculating the distance
  distance= duration*0.034/2;
  
  // Prints the info on the Serial Monitor
  SerialUSB.print("Distance: ");
  SerialUSB.println(distance);
  SerialUSB.print("Valuatio: ");
  SerialUSB.println(val);
  SerialUSB.print("Icinesss: ");
  SerialUSB.println(iciness);

}
